/** @file configbox.h

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2012.03.24 -

	@brief [ config box ]
*/

#ifndef _CONFIGBOX_H_
#define _CONFIGBOX_H_

#include <windows.h>
#include "config.h"

enum ConfigBoxParamId {
	FddType,
	WavReverse,
	WavHalf,
	WavCorrect,
	WavCorrectType,
	WavSampleRate,
	WavSampleBits,
	IOPort
};

/**
	@brief config dialog
*/
class ConfigBox
{
private:
	HINSTANCE  hInstance;
	EMU       *emu;
	config_t  *pConfig;

	int        fdd_type;

	int        wav_reverse;
	int        wav_half;
	int        wav_correct;
	int        wav_correct_type;

	int        wav_sample_rate;
	int        wav_sample_bits;

	int	       io_port;

	static INT_PTR CALLBACK ConfigBoxProc(HWND, UINT, WPARAM, LPARAM);

	INT_PTR onInitDialog(HWND, UINT, WPARAM, LPARAM);
	INT_PTR onOK(HWND, UINT, WPARAM, LPARAM);
public:
	ConfigBox(HINSTANCE, EMU *, config_t *);
	~ConfigBox();
	INT_PTR Show(HWND);
	void Update();
	int GetParam(ConfigBoxParamId);
};

#endif
