/** @file keybindbox.h

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2012.03.31 -

	@brief [ keybind box ]
*/

#ifndef _KEYBINDBOX_H_
#define _KEYBINDBOX_H_

#include <windows.h>
#include "keybindctrl.h"

#define MAX_TAB_NUM 2
#define MAX_PRESET_NUM	4

/**
	@brief keybind dialog
*/
class KeybindBox
{
private:
	HINSTANCE hInstance;
	KeyBindControl *kbctl[MAX_TAB_NUM];

	UINT16 vmkey_map[MAX_TAB_NUM][KBCTRL_MAX_LINES];
	int    vmkey_map_size[MAX_TAB_NUM];
	UINT32 *vkkey_defmap[MAX_TAB_NUM];
	int     vkkey_defmap_rows[MAX_TAB_NUM];
	int     vkkey_defmap_cols[MAX_TAB_NUM];
	UINT32 *vkkey_map[MAX_TAB_NUM];
	UINT32 *vkkey_preset_map[MAX_TAB_NUM][MAX_PRESET_NUM];

	_TCHAR vm_label[100];
	_TCHAR vk_label[100];
	_TCHAR vj_label[100];

	int selected_tabctrl;

	static INT_PTR CALLBACK	Proc(HWND, UINT, WPARAM, LPARAM);

	INT_PTR onInitDialog(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
	INT_PTR onClickOk(HWND hDlg);
	INT_PTR onClickLoadDefault(HWND hDlg);
	INT_PTR onClickLoadPreset(HWND hDlg, int idx);
	INT_PTR onClickSavePreset(HWND hDlg, int idx);

	void select_tabctrl(HWND hDlg, int tab_num);

public:
	KeybindBox(HINSTANCE);
	~KeybindBox() {};

	INT_PTR Show(HWND hWnd);

	void SetVmKeyMap(int tab_num, UINT16 *vmKeyMap, int size);
	void SetVkKeyDefMap(int tab_num, UINT32 *vkKeyDefMap, int rows, int cols);
	void SetVkKeyMap(int tab_num, UINT32 *vkKeyMap);
	void SetVkKeyPresetMap(int tab_num, UINT32 *vkKeyMap, int idx);
	void SetVmKey(int tab_num, int idx, UINT16 code);
	void SetTitleLabel(_TCHAR *vm, _TCHAR *vk, _TCHAR *vj);
};

#endif
